=== debian/changelog ===
libmcfp (1.2.3-1) unstable; urgency=medium

  * New upstream. 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 10:29:54 +0100

libmcfp (1.2.2-3) unstable; urgency=medium

  * Team upload.
  * Fix short description
  * Standards-Version: 4.6.1 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Settle with script name run-unit-test for autopkgtest
  * Provide run-unit-test as user example as well

 -- Andreas Tille <tille@debian.org>  Thu, 24 Nov 2022 13:11:29 +0100

libmcfp (1.2.2-2) unstable; urgency=medium

  * Fix link in control file.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 24 Nov 2022 08:06:11 +0100

libmcfp (1.2.2-1) unstable; urgency=medium

  * New upstream
  * Added autopkgtest
  * Initial release. (Closes: #1024622)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 15 Nov 2022 16:26:09 +0100
