=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTING=ON
