=== debian/changelog ===
libmcfp (1.2.4-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 15 Aug 2023 09:08:24 +0200
