## libmcfp 1.3.4

=== debian/changelog ===
libmcfp (1.3.4-1) unstable; urgency=medium

  * New upstream version 1.3.4

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 21 Jan 2025 09:04:42 +0100
