=== debian/control ===
--- 
+++ 
@@ -4,16 +4,16 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13),
-               libboost-dev,
+               catch2,
                cmake
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libmcfp
 Vcs-Git: https://salsa.debian.org/med-team/libmcfp.git
 Homepage: https://github.com/mhekkel/libmcfp
 Rules-Requires-Root: no
 
 Package: libmcfp-dev
-Architecture: any
+Architecture: all
 Section: libdevel
 Depends: ${misc:Depends}
 Description: header only configuration parser library
