=== debian/changelog ===
libmcfp (1.3.5-2) unstable; urgency=medium

  * changing type to all was not such a good idea after all

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 16:33:21 +0100

libmcfp (1.3.5-1) unstable; urgency=medium

  * New upstream version 1.3.5

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 16:32:06 +0100
