=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Rules-Requires-Root: no
 
 Package: libmcfp-dev
-Architecture: all
+Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}
 Description: header only configuration parser library
