## libmcfp 1.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # SPDX-License-Identifier: BSD-2-Clause
 #
-# Copyright (c) 2022 Maarten L. Hekkelman
+# Copyright (c) 2022-2025 Maarten L. Hekkelman
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -25,17 +25,13 @@
 cmake_minimum_required(VERSION 3.23)
 
 # set the project name
-project(mcfp VERSION 1.3.5 LANGUAGES CXX)
+project(mcfp VERSION 1.4.2 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
 
-include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
+include(CPM)
 include(CTest)
-
-set(CXX_EXTENSIONS OFF)
-set(CMAKE_CXX_STANDARD 17 CACHE STRING "The minimum version of C++ required for this library")
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 option(BUILD_DOCUMENTATION "Build the documentation" OFF)
 
@@ -49,32 +45,12 @@
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
 endif()
 
-if(MSVC)
-	# make msvc standards compliant...
-	add_compile_options(/permissive-)
-
-	if(${CMAKE_SYSTEM_VERSION} GREATER_EQUAL 10) # Windows 10
-		add_definitions(-D _WIN32_WINNT=0x0A00)
-	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
-		add_definitions(-D _WIN32_WINNT=0x0603)
-	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
-		add_definitions(-D _WIN32_WINNT=0x0602)
-	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
-		add_definitions(-D _WIN32_WINNT=0x0601)
-	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
-		add_definitions(-D _WIN32_WINNT=0x0600)
-	else() # Windows XP (5.1)
-		add_definitions(-D _WIN32_WINNT=0x0501)
-	endif()
-
-	add_definitions(-DNOMINMAX)
-endif()
-
 add_library(mcfp INTERFACE)
 add_library(mcfp::mcfp ALIAS mcfp)
 
 target_compile_features(mcfp INTERFACE cxx_std_20)
 
+# My god... why?
 if(MSVC)
 	target_compile_definitions(mcfp INTERFACE NOMINMAX=1)
 endif()
@@ -104,6 +80,13 @@
 	install(CODE "file(REMOVE_RECURSE ${OLD_CONFIG_FILES})")
 endif()
 
+# And an old include file
+if(EXISTS ${CMAKE_INSTALL_FULL_INCLUDEDIR}/mcfp.hpp)
+	message(
+		WARNING "Installation will remove old header file: ${CMAKE_INSTALL_FULL_INCLUDEDIR}/mcfp.hpp")
+	install(CODE "file(REMOVE ${CMAKE_INSTALL_FULL_INCLUDEDIR}/mcfp.hpp)")
+endif()
+
 install(TARGETS mcfp
 	EXPORT mcfp
 	FILE_SET mcfp_headers
@@ -123,28 +106,10 @@
 	COMPATIBILITY AnyNewerVersion)
 
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/mcfpConfig.cmake"
- 	"${CMAKE_CURRENT_BINARY_DIR}/mcfpConfigVersion.cmake"
+	"${CMAKE_CURRENT_BINARY_DIR}/mcfpConfigVersion.cmake"
 	DESTINATION lib/cmake/mcfp)
 
-# Install old config file, for use in older code
-install(EXPORT mcfp
-	NAMESPACE libmcfp::
-	DESTINATION lib/cmake/libmcfp
-	FILE "libmcfpTargets.cmake")
-
-configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/libmcfpConfig.cmake.in
-	${CMAKE_CURRENT_BINARY_DIR}/libmcfpConfig.cmake
-	INSTALL_DESTINATION lib/cmake/libmcfp)
-write_basic_package_version_file(
-	${CMAKE_CURRENT_BINARY_DIR}/libmcfpConfigVersion.cmake
-	VERSION ${PROJECT_VERSION}
-	COMPATIBILITY AnyNewerVersion)
-
-install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libmcfpConfig.cmake"
-	"${CMAKE_CURRENT_BINARY_DIR}/libmcfpConfigVersion.cmake"
-	DESTINATION lib/cmake/libmcfp)
-
-if(BUILD_TESTING)
+if(BUILD_TESTING AND PROJECT_IS_TOP_LEVEL)
 	add_subdirectory(test)
 endif()
