=== debian/changelog ===
libmcfp (1.4.2-2) unstable; urgency=medium

  * update standard version

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 01 Sep 2025 07:46:10 +0200

libmcfp (1.4.2-1) unstable; urgency=medium

  * New upstream version 1.4.2

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 26 May 2025 10:39:21 +0200
