=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                catch2,
                cmake
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libmcfp
 Vcs-Git: https://salsa.debian.org/med-team/libmcfp.git
 Homepage: https://github.com/mhekkel/libmcfp
