=== debian/rules ===
--- 
+++ 
@@ -11,4 +11,4 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DENABLE_TESTING=ON
+	dh_auto_configure -- -DENABLE_TESTING=ON -DCPM_USE_LOCAL_PACKAGES=ON
