=== debian/tests/control ===
Tests: run-unit-test
Depends: build-essential, cmake, @
Restrictions: allow-stderr
