=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libmcfp-$1\.tar\.gz/ \
  https://github.com/mhekkel/libmcfp/tags .*/v?(\d\S+)\.tar\.gz
